Unit PixJoy;

Interface

Type
	P_Joystick=Record
   	X,Y:Word;
      B1,B2:Boolean;
      Up,Down,Left,Right:Boolean;
      CalX1,CalY1,CalX2,CalY2:Word;
   End;

Function P_AutoCalibJoy(WJoy:Byte):Boolean;
Procedure P_ReadJoy(WJoy:Byte);
Function P_DetectJoy(WJoy:Byte):Boolean;

Var
	Joy:Array[1..2] Of P_Joystick;

Implementation

Uses
	Crt;

Function P_AutoCalibJoy(WJoy:Byte):Boolean;
Var
	Key:Char;
Begin
   Asm
   	mov AH,0
      mov AL,3h
      int 10h
   End;
   TextColor(7);
   TextBackground(0);
   ClrScr;
   If Not P_DetectJoy(WJoy) Then
   Begin
   	P_AutoCalibJoy:=False;
      Exit;
   End;
   WriteLn('Please swirl your joystick #',WJoy,' to all it''s extents, then press button #1.');
   WriteLn('Press ESC to cancel.');
   GotoXY(31,9);
   Write('ͻ');
   GotoXY(31,10);
   Write('      ');
   GotoXY(31,11);
   Write('Ķ');
   GotoXY(31,12);
   Write('      ');
   GotoXY(31,13);
   Write('Ķ');
   GotoXY(31,14);
   Write('      ');
   GotoXY(31,15);
   Write('ͼ');
   GotoXY(1,1);
   Joy[WJoy].CalX1:=60000;
   Joy[WJoy].CalY1:=60000;
   Joy[WJoy].CalX2:=0;
   Joy[WJoy].CalY2:=0;
   Repeat
   	P_ReadJoy(WJoy);
      With Joy[WJoy] Do
      Begin
         If Not((Left And Right) Or (Up And Down)) Then
         Begin
		      If Left And Up Then
		      Begin
		         Mem[$B800:1502]:=219;
		         Mem[$B800:1504]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1502]:=0;
		         Mem[$B800:1504]:=0;
	         End;
		      If Left And Down Then
		      Begin
		         Mem[$B800:2142]:=219;
		         Mem[$B800:2144]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:2142]:=0;
		         Mem[$B800:2144]:=0;
	         End;
	         If Left And (Not (Down Or Up)) Then
		      Begin
		         Mem[$B800:1822]:=219;
		         Mem[$B800:1824]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1822]:=0;
		         Mem[$B800:1824]:=0;
	         End;
	         If Up And (Not(Left Or Right)) Then
		      Begin
		         Mem[$B800:1508]:=219;
		         Mem[$B800:1510]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1508]:=0;
		         Mem[$B800:1510]:=0;
	         End;
	         If Down And (Not(Left Or Right)) Then
		      Begin
		         Mem[$B800:2148]:=219;
		         Mem[$B800:2150]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:2148]:=0;
		         Mem[$B800:2150]:=0;
	         End;
		      If Right And Up Then
		      Begin
		         Mem[$B800:1514]:=219;
		         Mem[$B800:1516]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1514]:=0;
		         Mem[$B800:1516]:=0;
	         End;
		      If Right And Down Then
		      Begin
		         Mem[$B800:2154]:=219;
		         Mem[$B800:2156]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:2154]:=0;
		         Mem[$B800:2156]:=0;
	         End;
	         If Right And (Not (Down Or Up)) Then
		      Begin
		         Mem[$B800:1834]:=219;
		         Mem[$B800:1836]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1834]:=0;
		         Mem[$B800:1836]:=0;
	         End;
	      	If Not (Left Or Right Or Up Or Down) then
		      Begin
		         Mem[$B800:1828]:=219;
		         Mem[$B800:1830]:=219;
		      End
	         Else
	         Begin
		         Mem[$B800:1828]:=0;
		         Mem[$B800:1830]:=0;
	         End;
      	End;
      End;

      With Joy[WJoy] Do
      Begin
      	If X<CalX1 Then
   			CalX1:=X;
         If Y<CalY1 Then
         	CalY1:=Y;
         If X>CalX2 Then
         	CalX2:=X;
         If Y>CalY2 Then
         	CalY2:=Y;
      End;
      If KeyPressed Then
      	Key:=ReadKey;
   Until (Joy[WJoy].B1) Or (Key=#27);
   If Key=#27 Then
   	P_AutoCalibJoy:=False
   Else
   	P_AutoCalibJoy:=True;
   ClrScr;
End;

Const
	Play=50;

Procedure P_ReadJoy(WJoy:Byte);
Var
   TimeOut:Word;
   P,Mask:Byte;
   X,Y,B1,B2:Byte;
Begin
   TimeOut:=0;
   If Not (WJoy In [1..2]) Then
   	Exit;
   If WJoy=1 Then
   Begin
   	Mask:=3;
      X:=1;
      Y:=2;
      B1:=16;
      B2:=32;
   End
   Else
   Begin
   	Mask:=12;
      X:=4;
      Y:=8;
      B1:=64;
      B2:=128;
   End;
	Joy[WJoy].X:=0;
	Joy[WJoy].Y:=0;
   Port[$201]:=0;
	Asm cli End;
	Repeat
      P:=Port[$201];
      If (P And X)<>0 Then
      	Inc(Joy[WJoy].X);
      If (P And Y)<>0 Then
      	Inc(Joy[WJoy].Y);
   	Inc(TimeOut);
   Until ((P And Mask)=0) Or (TimeOut=60000);
   Asm sti End;

	Joy[WJoy].B1:=P And B1=0;
	Joy[WJoy].B2:=P And B2=0;

   With Joy[WJoy] Do
   Begin
   	Left:=X<CalX1+Play;
   	Right:=X>CalX2-Play;
   	Up:=Y<CalY1+Play;
   	Down:=Y>CalY2-Play;
   End;
End;

Function P_DetectJoy(WJoy:Byte):Boolean;
Begin
   If Not WJoy In [1..2] Then
   Begin
   	P_DetectJoy:=False;
      Exit;
   End;
	P_ReadJoy(WJoy);
   P_DetectJoy:=Joy[WJoy].X<>60000;
End;

End.