(* PIXMath version 1 *)
Unit PixMath;

Interface

Type
	ar360r=Array[0..360] of Real;

Type
	P_FP=Record
   	HiPart:Integer;
      LoPart:Integer;
      Decimal:Byte;
   End;

Procedure P_CreateFP(Rl:Real;Decim:Byte;Var P:P_FP);
Procedure P_AddFP(N1,N2:P_FP;Var P:P_FP);
Procedure P_SubFP(N1,N2:P_FP;Var P:P_FP);
Procedure P_MulFP(N1,N2:P_FP;Var P:P_FP);
Procedure P_DivFP(N1,N2:P_FP;Var P:P_FP);
Function P_MakeReal(FP:P_FP):Real;

Function p_power(base:real;exp:integer):real;
Function p_btwn(min, num, max:integer):integer;
Function p_reangle(ang:integer):integer;
Function p_Distr(X,Y,X2,Y2:Real):Real;
Function p_disti(x,y,x2,y2:integer):integer;
Procedure p_Trig(Dist:Real;Ang,X,Y:Integer;Var X2,Y2:Integer);
Function p_ANGLE (stx, sty, fx, fy:real):real;
Function p_fixang(ang,rng:integer):integer;
Function p_RAP(SMALL, NUM, LARGE:integer):integer;

implementation
var pcos,psin:array [0..360] of real;

Procedure P_CreateFP(Rl:Real;Decim:Byte;Var P:P_FP);
Begin
	P.Decimal:=Decim;
   P.HiPart:=Trunc(Rl);
   P.LoPart:=Trunc(Frac(Rl)*(Decim*10));
End;

Procedure P_AddFP(N1,N2:P_FP;Var P:P_FP);
Begin
   If N1.Decimal>N2.Decimal Then
   	N1.Decimal:=N2.Decimal;
   If N1.Decimal<N2.Decimal Then
   	N2.Decimal:=N1.Decimal;
	N1.HiPart:=N1.HiPart+N2.HiPart;
	N1.LoPart:=N1.LoPart+N2.LoPart;
   If N1.LoPart>=(N1.Decimal*10) Then
   	;
End;

Procedure P_SubFP(N1,N2:P_FP;Var P:P_FP);
Begin
End;

Procedure P_MulFP(N1,N2:P_FP;Var P:P_FP);
Begin
End;

Procedure P_DivFP(N1,N2:P_FP;Var P:P_FP);
Begin
End;

Function P_MakeReal(FP:P_FP):Real;
Begin
End;



function p_power(base:real;exp:integer):real;
begin
if exp=0 then
   p_power:=1
else if exp=1 then p_power:=base
else
  p_power:=base*p_power(base,exp-1)
end;
FUNCTION p_btwn(min, num, max:integer):integer;
begin
   IF num < min THEN num:= min;
   IF num > max THEN num:= max;
   p_btwn:=num
END;

function p_reangle(ang:integer):integer;
begin
   while ang>360 do
      ang:=ang-360;
   while ang<0 do
      ang:=ang+360;

   if (ang<0) or (ang>360) then
       p_reangle:=p_reangle(ang)
   else
      p_reangle:=ang;
end;
Function p_Distr(X,Y,X2,Y2:Real):Real;
   Begin
   p_Distr:=Sqrt(Sqr(abs(X-X2))+Sqr(abs(Y-Y2)))
   End;
function p_disti(x,y,x2,y2:integer):integer;
begin
   p_disti:=trunc(sqrt(sqr(abs(x-x2))+sqr(abs(y-y2))));
end;
procedure p_Trig(Dist:Real;Ang,X,Y:Integer;Var X2,Y2:Integer);
   Begin
      ang:=p_reangle(ang);
      X2:=Trunc(Dist * pSin[Ang]+0.49+X);
      Y2:=Y-Trunc(Dist * pCos[Ang]+0.49);
   End;

  FUNCTION p_ANGLE (stx, sty, fx, fy:real):real;
  var p57:real;
      nw:integer;
  begin
 P57:= 57.29583;
  IF fx = stx THEN fx:= fx + 0.1;
  IF fy = sty THEN fy:= fy + 0.1;

      NW:= trunc(ArcTaN((stx - fx) / (sty - fy)) * P57);

  nw:=abs(nw);
  IF (fx >= stx) AND (fy >= sty) THEN
   begin NW:= 91 - NW; NW:= NW + 90 end;
  IF (fx <= stx) AND (fy >= sty) THEN NW:= 180 + NW;
  IF (fx <= stx) AND (fy <= sty) THEN
     begin NW:= 91 - NW; NW:= NW + 270 end;
 p_ANGLE:= p_REANGLE(NW);
END;
function p_fixang(ang,rng:integer):integer;
   begin
   p_fixang:=trunc(ang+rng/2) div rng *rng
   end;

FUNCTION p_RAP(SMALL, NUM, LARGE:integer):integer;
  {v5.0}
begin
   while num>large do num:=num-large;
   while num<small do num:=num+large;
      p_RAP:=NUM-(small-1);
END;


procedure p_init_trig_array;
var trig:integer;
begin
   for trig:=0 to 360 do
begin
  pcos[trig]:=cos(trig*pi/180);
  psin[trig]:=sin(trig*pi/180);
end;
end;
begin
   p_init_trig_array;
end.