Unit PixMouse;

Interface

Function P_ResetMouse:Boolean;
Function P_GetButNum:Integer;
Function P_MouseIdle:Boolean;
Procedure P_ShowMouse;
Procedure P_HideMouse;
Procedure P_DrawMouse;
Procedure P_LoadCursor(CurFile:String;NHX,NHY:Integer);
Procedure P_DeAllocCursor;

Var
	MouseX,MouseY:Integer;
   MouseB1,MouseB2,MouseB3:Boolean;
   MouseVisible:Boolean;

Implementation

Uses
	Pix322,PixSprit,Dos;

Var
	AX,BX,CX,DX:Integer;
   Cur,Bkg:Pointer;
   HotSpotX,HotSpotY:Integer;
   BkX,BkY:Integer;
   CurAllocated:Boolean;

Procedure CallMouse;
Var
	R:Registers;
Begin
	R.Ax:=AX;
   R.Bx:=BX;
   R.Cx:=CX;
   R.Dx:=DX;
   Intr($33,R);
   AX:=R.Ax;
   BX:=R.Bx;
   CX:=R.Cx;
   DX:=R.Dx;
End;

Function P_ResetMouse:Boolean;
Begin
	AX:=0;
   MouseX:=0;
   MouseY:=0;
   HotSpotX:=0;
   HotSpotY:=0;
   CallMouse;
   P_ResetMouse:=AX=$FFFF;
   MouseB1:=False;
   MouseB2:=False;
   MouseVisible:=False;
   CurAllocated:=False;
End;

Function P_GetButNum:Integer;
Begin
	AX:=$0011;
   CallMouse;
   P_GetButNum:=BX;
End;

Function P_MouseIdle:Boolean;
Var
	Motion:Boolean;
Begin
   P_MouseIdle:=False;
	AX:=$000B;
   CallMouse;
   Motion:=False;
   If CX<>0 Then
   Begin
   	P_MouseIdle:=True;
      Inc(MouseX,CX);
      If MouseX<0 Then MouseX:=0;
      If MouseX>319 Then MouseX:=319;
      Motion:=True;
   End;
   If DX<>0 Then
   Begin
   	P_MouseIdle:=True;
      Inc(MouseY,DX);
      If MouseY<0 Then MouseY:=0;
      If MouseY>199 Then MouseY:=199;
      Motion:=True;
   End;
	AX:=$0003;
   CallMouse;
   If (BX And 1=1) Then
   	MouseB1:=True
   Else
   	MouseB1:=False;
   If (BX And 2=2) Then
   	MouseB2:=True
   Else
   	MouseB2:=False;
   If (BX And 4=4) Then
   	MouseB3:=True
   Else
   	MouseB3:=False;
   If Motion Then
		P_DrawMouse;
End;

Procedure P_ShowMouse;
Var
	OS,OO:Word;
   Wd,Hg:Integer;
Begin
	If MouseVisible Then Exit;
   If Not CurAllocated Then Exit;
   OS:=Seg(Cur^);
   OO:=Ofs(Cur^);
	Asm
      push DS
      mov AX,OS
      mov DS,AX
      mov SI,OO
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      pop DS
   End;
   OS:=PSeg;
   OO:=POfs;
   P_SelPage(0);
   BkX:=MouseX-HotSpotX;
   BkY:=MouseY-HotSpotY;
   If BkX<0 Then BkX:=0;
   If BkY<0 Then BkY:=0;
   If BkX+Wd>319 Then BkX:=319-Wd;
   If BkY+Hg>199 Then BkY:=199-Hg;
   P_GetImage(BkX,BkY,BkX+Wd-1,BkY+Hg-1,Bkg);
   P_PutImageTransClip(MouseX-HotSpotX,MouseY-HotSpotY,Cur);
   MouseVisible:=True;
   PSeg:=OS;
   POfs:=OO;
End;

Procedure P_HideMouse;
Var
	OS,OO:Word;
Begin
	If Not MouseVisible Then Exit;
   If Not CurAllocated Then Exit;
   OS:=PSeg;
   OO:=POfs;
   P_SelPage(0);
   P_PutImage(BkX,BkY,Bkg);
   MouseVisible:=False;
   PSeg:=OS;
   POfs:=OO;
End;

Procedure P_DrawMouse;
Var
	OS,OO:Word;
   Wd,Hg:Word;
Begin
	If Not MouseVisible Then Exit;
   If Not CurAllocated Then Exit;
   OS:=Seg(Cur^);
   OO:=Ofs(Cur^);
	Asm
   	push DS
      mov AX,OS
      mov DS,AX
      mov SI,OO
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      pop DS
   End;
   OS:=PSeg;
   OO:=POfs;
   P_SelPage(0);
   P_PutImage(BkX,BkY,Bkg);
   BkX:=MouseX-HotSpotX;
   BkY:=MouseY-HotSpotY;
   If BkX+Wd>319 Then BkX:=319-Wd;
   If BkY+Hg>199 Then BkY:=199-Hg;
   If BkX<0 Then BkX:=0;
   If BkY<0 Then BkY:=0;
   P_GetImage(BkX,BkY,BkX+Wd-1,BkY+Hg-1,Bkg);
   P_PutImageTransClip(MouseX-HotSpotX,MouseY-HotSpotY,Cur);
   PSeg:=OS;
   POfs:=OO;
End;

Procedure P_LoadCursor(CurFile:String;NHX,NHY:Integer);
Var
	F:File;
Begin
   If CurAllocated Then
   Begin
   	P_DeAlloc(Cur);
      P_DeAlloc(Bkg);
   End;
	P_LoadPRIAlloc(CurFile,Cur);
	P_LoadPRIAlloc(CurFile,Bkg);
   CurAllocated:=True;
   HotSpotX:=NHX;
   HotSpotY:=NHY;
End;

Procedure P_DeAllocCursor;
Begin
	If Not CurAllocated Then
   	Exit;
   P_DeAlloc(Cur);
   P_DeAlloc(Bkg);
   CurAllocated:=False;
End;

Begin
	P_ResetMouse;
End.