Unit PixPei;

{$I-}

Interface

Uses
	Pix322;

Type
   P_PEIHdr=Record
   	Mark:Array[1..3] Of Char;
      Version:Byte;
      Wd,Hg:Word;
      Compression:Byte;
   End;

   P_PEI=Object
		H:P_PEIHdr;
      Data:Pointer;
      Pal:TPalette;
      Constructor Init;
      Procedure Assign(Var P:Pointer);
      Procedure Copy(P:Pointer);
      Procedure UnRLE(Var F:File);
      Procedure Load(FName:String);
      Procedure RLE(Var F:File);
      Procedure Save(FName:String);
      Procedure Flush;
      Destructor Done;
   End;

	PcxHdr=Record
   	ID:Byte;
      Version:Byte;
      RLE:Byte;
      BPP:Byte;
      X,Y:Integer;
      X2,Y2:Integer;
      Hr,Vr:Integer;
      Pal16:Array[1..48] Of Byte;
      Reserved:Byte;
      Planes:Byte;
      BPL:Integer;
      PalType:Integer;
      Nothing:Array[1..58] Of Byte;
   End;

Function P_LoadPcx(FName:String;Var P:Pointer;Var Pal:TPalette):Boolean;
Procedure P_WritePcxInfo(FName:String);

Implementation

Constructor P_PEI.Init;
Begin
	Data:=Nil;
   H.Compression:=1;
End;

Procedure P_PEI.Assign(Var P:Pointer);
Var
	Buf:BufP Absolute P;
Begin
	Move(Buf^[0],H.Wd,2);
	Move(Buf^[2],H.Hg,2);
   Data:=P;
End;

Procedure P_PEI.Copy(P:Pointer);
Var
	Buf:BufP Absolute P;
Begin
   Flush;
	Move(Buf^[0],H.Wd,2);
	Move(Buf^[2],H.Hg,2);
   GetMem(Data,H.Wd*H.Hg+4);
   If Data=Nil Then
   	Exit;
   Move(P^,Data^,H.Wd*H.Hg+4);
End;

Procedure P_PEI.UnRLE(Var F:File);
Var
   Buf:BufP Absolute Data;
   C,Cur:Word;
   B,N:Byte;
   TBf:Array[1..10000] Of Byte;
   TOf:Word;
   NIB:Word;
Begin
   Move(H.Wd,Buf^[0],2);
   Move(H.Hg,Buf^[2],2);
   Cur:=4;
   BlockRead(F,TBf,10000,NIB);
   TOf:=1;
	While(Cur<Word(H.Wd*H.Hg+4)) Do
   Begin
      B:=TBf[TOf];
      Inc(TOf);
      If TOf>NIB Then
      Begin
   		BlockRead(F,TBf,10000,NIB);
         TOf:=1;
      End;
		If B>=192 Then
      Begin
      	N:=B-192;
      	B:=TBf[TOf];
	      Inc(TOf);
	      If TOf>NIB Then
	      Begin
	   		BlockRead(F,TBf,1024,NIB);
	         TOf:=1;
	      End;
         For C:=1 To N Do
         	Buf^[Cur+C-1]:=B;
      	Cur:=Cur+N;
      End
      Else
      Begin
      	Buf^[Cur]:=B;
         Cur:=Cur+1;
      End;
   End;
End;

Procedure P_PEI.Load(FName:String);
Var
	F:File;
   Buf:BufP;
Begin
	Flush;
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PEI';
   System.Assign(F,FName);
   Reset(F,1);
   If IOResult<>0 Then
   	Exit;
   BlockRead(F,H,SizeOf(H));
   If (H.Mark<>'PEI') Or (H.Version<>1) Or (IOResult<>0) Then
   Begin
   	Close(F);
      Exit;
   End;
   GetMem(Data,H.Wd*H.Hg+4);
   If Data=Nil Then
   Begin
   	Close(F);
   	Exit;
   End;
   BlockRead(F,Pal,SizeOf(Pal));
   If IOResult<>0 Then
   Begin
      Close(F);
      Flush;
   	Exit;
   End;
	If H.Compression=1 Then
   	UnRLE(F)
   Else
   Begin
   	BlockRead(F,Data^,H.Wd*H.Hg+4);
      If (IOResult<>0) Then
      Begin
      	Close(F);
         Flush;
         Exit;
      End;
   End;
	Close(F);
   If IOResult>0 Then
   	Exit;
End;

Procedure P_PEI.RLE(Var F:File);
Var
	Buf:BufP Absolute Data;
   Cur:Word;
   LB,B:Byte;
   Cnt:Word;
   TBf:Array[1..10000] Of Byte;
   TOf:Word;
   Procedure PutB(By:Byte);
   Begin
   	Tbf[TOf]:=By;
      Inc(TOf);
      If TOf>10000 Then
      Begin
      	BlockWrite(F,TBf,10000);
         TOf:=1;
      End;
   End;
Begin
	TOf:=1;
   Cur:=4;
   Cnt:=0;
   LB:=Buf^[Cur];
   While(Cur<H.Wd*H.Hg+4) Do
   Begin
      B:=Buf^[Cur];
		If B=LB Then
      	Inc(Cnt)
      Else
      Begin
      	If Cnt=1 Then
         Begin
         	If LB>=192 Then
            	PutB(193);
            PutB(LB);
            LB:=B;
            Cnt:=1;
         End
         Else
         Begin
         	While Cnt>63 Do
            Begin
            	PutB(255);
               PutB(LB);
               Dec(Cnt,63);
            End;
            PutB(192+Cnt);
            PutB(LB);
            Cnt:=1;
            LB:=B;
         End;
      End;
      Inc(Cur);
   End;
   If TOf=1 Then
   	Exit;
   BlockWrite(F,Tbf,TOf-1);
End;

Procedure P_PEI.Save(FName:String);
Var
	F:File;
Begin
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PEI';
	System.Assign(F,FName);
   Rewrite(F,1);
   If IOResult<>0 Then
   	Exit;
   H.Mark:='PEI';
   H.Version:=1;
   BlockWrite(F,H,SizeOf(H));
   BlockWrite(F,Pal,SizeOf(Pal));
   If H.Compression=1 Then
   	RLE(F)
   Else
   	BlockWrite(F,Data^,H.Wd*H.Hg+4);
   Close(F);
   If IOResult>0 Then
   	Exit;
End;

Procedure P_PEI.Flush;
Begin
	If Data<>Nil Then
   	FreeMem(Data,H.Wd*H.Hg+4);
End;

Destructor P_PEI.Done;
Begin
	Flush;
End;


Function P_LoadPcx(FName:String;Var P:Pointer;Var Pal:TPalette):Boolean;
Var
   F:File;
   H:PcxHdr;
   Wd,Hg:Integer;
   Buf:BufP;
   C,Cur:Word;
   B,N:Byte;
   TBf:Array[1..10000] Of Byte;
   TOf:Word;
   NIB:Word;
Begin
	P_LoadPcx:=False;
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PCX';
   Assign(F,FName);
   Reset(F,1);
   If IOResult>0 Then
   	Exit;
   BlockRead(F,H,128);
   If (H.ID<>$0A) Or (H.Version<>5) Or (IOResult>0) Then
   	Exit;
   Wd:=H.X2-H.X+1;
   Hg:=H.Y2-H.Y+1;
	P:=Nil;
   GetMem(P,Wd*Hg+4);
   If P=Nil Then
   Begin
      Close(F);
   	Exit;
   End;
   Buf:=P;
   Move(Wd,Buf^[0],2);
   Move(Hg,Buf^[2],2);
   Cur:=4;
   BlockRead(F,TBf,10000,NIB);
   TOf:=1;
	While(Cur<Word(Wd*Hg+4)) Do
   Begin
      B:=TBf[TOf];
      Inc(TOf);
      If TOf>NIB Then
      Begin
   		BlockRead(F,TBf,10000,NIB);
         TOf:=1;
      End;
		If B>=192 Then
      Begin
      	N:=B-192;
      	B:=TBf[TOf];
	      Inc(TOf);
	      If TOf>NIB Then
	      Begin
	   		BlockRead(F,TBf,1024,NIB);
	         TOf:=1;
	      End;
         For C:=1 To N Do
         	Buf^[Cur+C-1]:=B;
      	Cur:=Cur+N;
      End
      Else
      Begin
      	Buf^[Cur]:=B;
         Cur:=Cur+1;
      End;
   End;
   Seek(F,FileSize(F)-768);
   BlockRead(F,Pal,768);
   For C:=0 To 255 Do
   Begin
      Pal[C].R:=Pal[C].R Shr 2;
      Pal[C].G:=Pal[C].G Shr 2;
      Pal[C].B:=Pal[C].B Shr 2;
   End;
   Close(F);
   If IOResult>0 Then
   Begin
      FreeMem(P,Wd*Hg+4);
   	Exit;
   End;
	P_LoadPcx:=True;
End;

Procedure P_WritePcxInfo(FName:String);
Var
   F:File;
	H:PcxHdr;
Begin
   If Pos('.',FName)=0 Then
   	FName:=FName+'.PCX';
   Assign(F,FName);
   Reset(F,1);
   If IOResult>0 Then
   	Exit;
   BlockRead(F,H,128);
   Close(F);
   If (H.ID<>$0A) Or (H.Version<>5) Or (IOResult>0) Then
   	Exit;
   WriteLn(FName,' : PCX File Version 3.0');
   WriteLn('Size: ',H.X2-H.X+1,'x',H.Y2-H.Y+1);
End;

End.