(* PIXRes version 1 *)

Unit PixRes;
{ Ressource files management functions }


Interface

Type
   Str20=String[20];

   TResHeader=Record
   	Mark:String[16];
      Versie:Word;
      NbEntries:Word;
   End;

   TEntry=Record
		Tag:Str20;
      Siz:Word;
      Location:LongInt;
   End;

	TResFile=Object
   	Fil:File;
      Head:TResHeader;
      Opn:Boolean;
		Constructor Init;
      Function Create(FName:String;Entr:Word):Boolean;
      Function Open(FName:String):Boolean;
      Function Store(Tag:Str20;Dta:Pointer;Size:Word):Boolean;
      Function Read(Tag:Str20;Dta:Pointer):Boolean;
      Function SeekTo(Tag:Str20):Word;
      Function KillRef(Tag:Str20):Boolean;
      Destructor Done;
   End;

Implementation


Constructor TResFile.Init;
Begin
	Opn:=False;
End;

Function TResFile.Create(FName:String;Entr:Word):Boolean;
Var
	C:Integer;
   E:TEntry;
Begin
   Head.Mark:='Ressource file.'+Chr(26);
   Head.Versie:=1;
   Head.NbEntries:=Entr;
   E.Tag:='';
   E.Siz:=0;
   E.Location:=0;
	{$I-}
	   Assign(Fil,FName);
	   Rewrite(Fil,1);
      If IOResult>0 Then
      Begin
      	Create:=False;
         Exit;
      End;
      BlockWrite(Fil,Head,SizeOf(Head));
		For C:=1 To Entr Do
      	BlockWrite(Fil,E,SizeOf(E));
	{$I+}
   If IOResult=0 Then
		Create:=True
   Else
   Begin
   	Close(Fil);
      Create:=False;
      Exit;
   End;
   Opn:=True;
End;

Function TResFile.Open(FName:String):Boolean;
Begin
	{$I-}
	   Assign(Fil,FName);
	   Reset(Fil,1);
      If IOResult>0 Then
      Begin
      	Open:=False;
         Exit;
      End;
      BlockRead(Fil,Head,SizeOf(Head));
	{$I+}
	If (IOResult=0) And (Head.Mark='Ressource file.'+Chr(26)) And (Head.Versie=1) Then
		Open:=True
   else
   Begin
		Open:=False;
      Close(Fil);
      Exit;
   End;
   Opn:=True;
End;

Function TResFile.Store(Tag:Str20;Dta:Pointer;Size:Word):Boolean;
Var
	E,LE:TEntry;
   C:Integer;
   Ok:Boolean;
Begin
   If Not Opn Then
   Begin
   	Store:=False;
      Exit;
   End;
   E.Tag:='';
   E.Siz:=0;
   E.Location:=SizeOf(Head)+(Head.NbEntries*SizeOf(E));
   Ok:=False;
   C:=1;
	Seek(Fil,SizeOf(Head));
   Repeat
      LE:=E;
   	BlockRead(Fil,E,SizeOf(E));
   	If E.Tag=Tag Then
   	Begin
   		Store:=False;
      	Exit;
   	End;
      If E.Siz=0 Then
      Begin
      	Ok:=True;
         Dec(C);
      End;
      Inc(C);
	Until (C=Head.NbEntries+1) Or Ok;
	If C=Head.NbEntries+1 Then
   Begin
   	Store:=False;
      Exit;
   End;
   E.Tag:=Tag;
   E.Siz:=Size;
   E.Location:=LE.Location+LE.Siz;
   Seek(Fil,FilePos(Fil)-SizeOf(E));
   BlockWrite(Fil,E,SizeOf(E));
   Seek(Fil,E.Location);
   BlockWrite(Fil,Dta^,Size);
   If IOResult>0 Then
   	Store:=False
   Else
		Store:=True;
End;

Function TResFile.Read(Tag:Str20;Dta:Pointer):Boolean;
Var
	E:TEntry;
   C:Integer;
   Ok:Boolean;
Begin
   If Not Opn Then
   Begin
   	Read:=False;
      Exit;
   End;
   Ok:=False;
   C:=1;
	Seek(Fil,SizeOf(Head));
   Repeat
   	BlockRead(Fil,E,SizeOf(E));
   	If E.Tag=Tag Then
      Begin
      	Ok:=True;
         Dec(C);
      End;
      Inc(C);
	Until (C=Head.NbEntries+1) Or Ok;
	If C=Head.NbEntries+1 Then
   Begin
   	Read:=False;
      Exit;
   End;
   Seek(Fil,E.Location);
   BlockRead(Fil,Dta^,E.Siz);
   If IOResult>0 Then
   	Read:=False
   Else
		Read:=True;
End;

Function TResFile.SeekTo(Tag:Str20):Word;
Var
	E:TEntry;
   C:Integer;
   Ok:Boolean;
Begin
   If Not Opn Then
   Begin
      SeekTo:=0;
      Exit;
   End;
   Ok:=False;
   C:=1;
	Seek(Fil,SizeOf(Head));
   Repeat
   	BlockRead(Fil,E,SizeOf(E));
   	If E.Tag=Tag Then
      Begin
      	Ok:=True;
         Dec(C);
      End;
      Inc(C);
	Until (C=Head.NbEntries+1) Or Ok;
	If C=Head.NbEntries+1 Then
   Begin
   	SeekTo:=0;
      Exit;
   End;
   Seek(Fil,E.Location);
	SeekTo:=E.Siz;
End;

Function TResFile.KillRef(Tag:Str20):Boolean;
Var
	E:TEntry;
   C:Integer;
   Ok:Boolean;
Begin
   If Not Opn Then
   Begin
   	KillRef:=False;
      Exit;
   End;
   Ok:=False;
   C:=1;
	Seek(Fil,SizeOf(Head));
   Repeat
   	BlockRead(Fil,E,SizeOf(E));
   	If E.Tag=Tag Then
      Begin
      	Ok:=True;
         Dec(C);
      End;
      Inc(C);
	Until (C=Head.NbEntries+1) Or Ok;
	If C=Head.NbEntries+1 Then
   Begin
   	KillRef:=False;
      Exit;
   End;
   E.Tag:='';
   E.Location:=0;
   E.Siz:=1;
   Seek(Fil,FilePos(Fil)-SizeOf(E));
	BlockWrite(Fil,E,SizeOf(E));
   If IOResult>0 Then
   	KillRef:=False
   Else
		KillRef:=True;
End;

Destructor TResFile.Done;
Begin
	If Opn Then
   	Close(Fil);
End;


End.