Unit PixSound;

Interface

Function P_ResetSB:Boolean;
Function P_DetectSB:Boolean;
Procedure P_PlayPds(FName:String;AutoRepeat:Boolean);
Procedure P_StopPds;

Type
   TPdsHeader=Record
		Sig:String[18];
      Freq:LongInt;
      DataSize:LongInt;
   End;

Var
	IOBase:Word;
   IRQ,DMA:Byte;
   DSPMaj,DSPMin:Byte;
   PDSDone:Boolean;

Implementation

Uses
	Crt,Dos;

Procedure WriteDsp(B:Byte);
Begin
	While Port[IOBase+$0C] And $80=$80 Do ;
   Port[IOBase+$0C]:=B;
End;

Function ReadDsp:Byte;
Begin
	While Port[IOBase+$0A]=$AA Do ;
   ReadDsp:=Port[IOBase+$0A];
End;

Function P_ResetSB:Boolean;
Begin
	Port[IOBase+$06]:=1;
   Delay(10);
   Port[IOBase+$06]:=0;
   Delay(10);
   P_ResetSB:=Port[IOBase+$0A]=$AA;
End;

Function P_DetectSB:Boolean;
Var
	C:Word;
Begin
   P_DetectSB:=True;
	IOBase:=$210;
   While IOBase<=$280 Do
   Begin
   	If P_ResetSB Then
      	Exit;
   	Inc(IOBase,$10);
   End;
   If IOBase=$290 Then
   	P_DetectSB:=False;
End;

Var
	Pds:File;
   Block1,Block2:Pointer;
   PlayingBlock:Byte;
   LastBlock:Boolean;
	PDSTot,PDSRmn:LongInt;
   OldInt:Pointer;
   Know:Boolean;
	H:TPDSHeader;
   Bs:Word;
   Siz:Word;
   Rpt:Boolean;

Procedure ReadBlock;
Begin
   If PlayingBlock=2 Then
   	PlayingBlock:=1
   Else
   	PlayingBlock:=2;
	If PDSRmn<=BS Then
   Begin
   	If PlayingBlock=1 Then
			BlockRead(Pds,Block1^,PDSRmn)
      Else
			BlockRead(Pds,Block2^,PDSRmn);
      Siz:=PDSRmn;
      If Rpt Then
      Begin
      	PDSRmn:=PDSTot;
         Seek(Pds,SizeOf(H));
      End
      Else
      Begin
	      PDSRmn:=0;
	      LastBlock:=True;
   	End;
   End
   Else
   Begin
      If PlayingBlock=1 Then
   		BlockRead(Pds,Block1^,BS)
      Else
   		BlockRead(Pds,Block2^,BS);
      Siz:=BS;
      Dec(PDSRmn,BS);
   End;
End;


Type
	Pnt=Record
   	O,S:Word;
   End;

Procedure SendBlock;
Var
	P:LongInt;
   S,O:Word;
Begin
   If LastBlock And Know Then
   Begin
      WriteDsp($D0);
   	Port[$21]:=Port[$21] Or (1 Shl IRQ);
      SetIntVec($08+IRQ,OldInt);
		PDSDone:=True;
   	FreeMem(Block1,BS);
   	FreeMem(Block2,BS);
      Exit;
   End;
   WriteDsp($40);
   WriteDsp(256-LongInt(1000000 Div H.Freq));
   If PlayingBlock=1 Then
   	P:=16*LongInt(Pnt(Block1).S)+Pnt(Block1).O
   Else
   	P:=16*LongInt(Pnt(Block2).S)+Pnt(Block2).O;
   S:=Pnt(P).S;
   O:=Pnt(P).O;
	Port[$0A]:=5;
   Port[$0C]:=0;
   Port[$0B]:=$49;
   Port[$02]:=Lo(O);
   Port[$02]:=Hi(O);
   Port[$03]:=Lo(Siz-1);
   Port[$03]:=Hi(Siz-1);
   Port[$83]:=S;
   WriteDsp($14);
   WriteDsp(Lo(Siz-1));
   WriteDsp(Hi(Siz-1));
   Port[$0A]:=1;
	If LastBlock And (Not Know) Then
   	Know:=True
   Else
		ReadBlock;
End;

Procedure SBInt; Interrupt;
Var
	Dummy:Byte;
Begin
	Dummy:=Port[IOBase+$0E];
   SendBlock;
   Port[$20]:=$20;
End;

Procedure P_PlayPds(FName:String;AutoRepeat:Boolean);
Begin
   PDSDone:=False;
   Know:=False;
   Rpt:=AutoRepeat;
   {$I-}
   Assign(Pds,FName+'.PDS');
   Reset(Pds,1);
	BlockRead(Pds,H,SizeOf(H));
   If (H.Sig<>'PIX Digital Sound'#26) Or (IOResult>0) Then
   Begin
      PDSDone:=True;
   	Exit;
   End;
   BS:=16000;
   GetMem(Block1,BS);
   GetMem(Block2,BS);
   PdsTot:=H.DataSize;
   PdsRmn:=H.DataSize;
   LastBlock:=PdsTot<=BS;
   PlayingBlock:=2;
   GetIntVec($08+IRQ,OldInt);
   SetIntVec($08+IRQ,@SBInt);
   Port[$21]:=Port[$21] And (Not (1 Shl IRQ));
   WriteDsp($D1);
   ReadBlock;
   SendBlock;
   {$I+}
End;

Procedure P_StopPds;
Begin
   If PDSDone Then
   	Exit;
	WriteDsp($D0);
   Port[$21]:=Port[$21] Or (1 Shl IRQ);
   SetIntVec($08+IRQ,OldInt);
	PDSDone:=True;
   FreeMem(Block1,BS);
   FreeMem(Block2,BS);
End;

Begin
	PdsDone:=True;
End.