(* PIXSprit version 1 *)

Unit PixSprit;

{$G+}

Interface

Procedure P_SetClipRegion(X1,Y1,X2,Y2:Integer);
Function P_ImageSize(X1,Y1,X2,Y2:Integer):Word;
Procedure P_GetImage(X1,Y1,X2,Y2:Integer;Buf:Pointer);
Procedure P_PutImage(X,Y:Integer;Buf:Pointer);
Procedure P_PutImageTrans(X,Y:Integer;Buf:Pointer);
Procedure P_PutImageClip(X,Y:Integer;Buf:Pointer);
Procedure P_PutImageTransClip(X,Y:Integer;Buf:Pointer);
Procedure P_SavePRI(FName:String;Buf:Pointer);
Procedure P_LoadPRI(FName:String;Buf:Pointer);
Procedure P_SavePRIFile(Var F:File;Buf:Pointer);
Procedure P_LoadPRIFile(Var F:File;Buf:Pointer);
Function P_LoadPRIalloc(FName:String;Var Buf:Pointer):Boolean;
Procedure P_ShowPRI(FName:String;X,Y:Integer);
Function P_BufSize(Buf:Pointer):Word;
Function P_PRISize(FName:String):Word;
Procedure P_DeAlloc(Var Buf:Pointer);

Type
	P_Sprite=Object
      X,Y:Integer;
   	Img:Array[1..20,1..20] Of Pointer;
      NbFrm,CurFrm:Array[1..20] Of Byte;
      CurSet:Byte;
      Constructor Init;
      Procedure AddFrame(NSet:Byte;NImg:Pointer);
      Procedure NewSet(NSet:Byte);
      Procedure Draw;
      Procedure DrawTrans;
      Procedure DrawClip;
      Procedure DrawTransClip;
      Function Step:Boolean;
      Destructor Done;
   End;

Var
	WINX1,WINX2,WINY1,WINY2:Integer;

Implementation

Uses
	PIX322;

Procedure P_SetClipRegion(X1,Y1,X2,Y2:Integer);
Begin
	WINX1:=X1;
	WINX2:=X2;
	WINY1:=Y1;
	WINY2:=Y2;
End;

Function P_ImageSize(X1,Y1,X2,Y2:Integer):Word;
Begin
	P_ImageSize:=(X2-X1+1)*(Y2-Y1+1)+4;
End;

Procedure P_GetImage(X1,Y1,X2,Y2:Integer;Buf:Pointer);
Var
	Wd,Hg:Integer;
   DSg,DOf,PSg,POf:Word;
Begin
   Wd:=X2-X1+1;
   Hg:=Y2-Y1+1;
   DSg:=Seg(Buf^);
   DOf:=Ofs(Buf^);
   PSg:=PSeg;
   POf:=POfs;
	Asm
      push DS
      mov AX,[PSg]
      mov DS,AX
      mov SI,[POf]
   	mov AX,[DSg]
      mov ES,AX
      mov DI,[DOf]
   	mov AX,Y1
      mov BX,AX
      shl AX,8
      shl BX,6
      add AX,BX
      add AX,X1
      add SI,AX
      mov DX,Hg
      mov AX,Wd
      stosw
      mov AX,Hg
      stosw
     	mov BX,320
      sub BX,Wd
     @RG1:
     	mov CX,Wd
      rep movsb
      add SI,BX
      dec DX
      jnz @RG1
      pop DS
   End;
End;

Procedure P_PutImage(X,Y:Integer;Buf:Pointer);
Var
	SSg,SOf,PSg,POf:Word;
   Wd,Hg:Integer;
Begin
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   PSg:=PSeg;
   POf:=POfs;
	Asm
      push DS
      mov AX,[PSg]
      mov ES,AX
      mov DI,[POf]
   	mov AX,[SSg]
      mov DS,AX
   	mov SI,[SOf]
   	mov AX,Y
      mov BX,AX
      shl AX,8
      shl BX,6
      add AX,BX
      add AX,X
      add DI,AX
   	lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      mov AX,320
      sub AX,Wd
      mov BX,AX
      mov DX,Hg
     @DR1:
     	mov CX,Wd
      rep movsb
      add DI,BX
      dec DX
      jnz @DR1
      pop DS
   End;
End;

Procedure P_PutImageTrans(X,Y:Integer;Buf:Pointer);
Var
	SSg,SOf,PSg,POf:Word;
   Wd,Hg:Integer;
Begin
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   PSg:=PSeg;
   POf:=POfs;
	Asm
      push DS
      mov AX,[PSg]
      mov ES,AX
      mov DI,[POf]
   	mov AX,[SSg]
      mov DS,AX
   	mov SI,[SOf]
   	mov AX,Y
      mov BX,AX
      shl AX,8
      shl BX,6
      add AX,BX
      add AX,X
      add DI,AX
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      mov AX,320
      sub AX,Wd
      mov BX,AX
      mov DX,Hg
     @DT1:
     	mov CX,Wd
	  @DT2:
	  	lodsb
		test AL,0FFh
		jnz @DT3
      inc DI
      loop @DT2
      jmp @DT4
	  @DT3:
	  	stosb
		loop @DT2
     @DT4:
      add DI,BX
      dec DX
      jnz @DT1
      pop DS
   End;
End;

Procedure P_PutImageClip(X,Y:Integer;Buf:Pointer);
Var
	SSg,SOf,PSg,POf:Word;
   I:Integer;
   Wd,Hg:Integer;
   NX,NWd,Ia,Ib,NY,NHg:Integer;
   tDS,tES,tSI,tDI:Word;
Begin
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   PSg:=PSeg;
   POf:=POfs;
	Asm
      push DS
      mov AX,[PSg]
      mov ES,AX
      mov DI,[POf]
   	mov AX,[SSg]
      mov DS,AX
   	mov SI,[SOf]
   	lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      mov tDS,DS
      mov tES,ES
      mov tSI,SI
      mov tDI,DI
      pop DS
   End;
   If (X>WINX2-1) Or (X+Wd<WINX1+1) Then
   	Exit;
   If (Y>WINY2-1) Or (Y+Hg<WINY1+1) Then
   	Exit;
   NX:=X;
   NY:=Y;
   NWd:=Wd;
   NHg:=Hg;
   Ia:=0;
   Ib:=0;
   If Y<WINY1 Then
   Begin
      NY:=WINY1;
   	Inc(tSI,Wd*(WINY1-Y));
      NHg:=Hg-(WINY1-Y);
   End;
   If Y+Hg>WINY2 Then
   	NHg:=Hg-(Y+Hg-WINY2)-1;
   If NHg<=0 Then
   	Exit;
   If X<WINX1 Then
   Begin
   	NX:=WINX1;
      NWd:=Wd-(WINX1-X);
      Ib:=WINX1-X;
   End;
   If X+NWd>WINX2 Then
   Begin
   	Ia:=X+NWd-WINX2;
      NWd:=NWd-Ia;
   End;
   Asm
      push DS
      mov DS,tDS
      mov ES,tES
      mov SI,tSI
      mov DI,tDI
   	mov AX,NY
      mov BX,AX
      shl AX,8
      shl BX,6
      add AX,BX
      add AX,NX
      add DI,AX
      mov AX,320
      sub AX,NWd
      mov I,AX
      mov DX,NHg
     @DR1:
     	mov CX,NWd
      add SI,Ib
      rep movsb
      add SI,Ia
      add DI,I
      dec DX
      jnz @DR1
      pop DS
   End;
End;

Procedure P_PutImageTransClip(X,Y:Integer;Buf:Pointer);
Var
	SSg,SOf,PSg,POf:Word;
   I:Integer;
   Wd,Hg:Integer;
   NX,NWd,Ia,Ib,NY,NHg:Integer;
   tDS,tES,tSI,tDI:Word;
Begin
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   PSg:=PSeg;
   POf:=POfs;
	Asm
      push DS
      mov AX,[PSg]
      mov ES,AX
      mov DI,[POf]
   	mov AX,[SSg]
      mov DS,AX
   	mov SI,[SOf]
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      mov tDS,DS
      mov tES,ES
      mov tSI,SI
      mov tDI,DI
      pop DS
   End;
   If (X>WINX2-1) Or (X+Wd<WINX1+1) Then
   	Exit;
   If (Y>WINY2-1) Or (Y+Hg<WINY1+1) Then
   	Exit;
   NX:=X;
   NY:=Y;
   NWd:=Wd;
   NHg:=Hg;
   Ia:=0;
   Ib:=0;
   If Y<WINY1 Then
   Begin
      NY:=WINY1;
   	Inc(tSI,Wd*(WINY1-Y));
      NHg:=Hg-(WINY1-Y);
   End;
   If Y+Hg>WINY2 Then
   	NHg:=Hg-(Y+Hg-WINY2)-1;
   If NHg<=0 Then
   	Exit;
   If X<WINX1 Then
   Begin
   	NX:=WINX1;
      NWd:=Wd-(WINX1-X);
      Ib:=WINX1-X;
   End;
   If X+NWd>WINX2 Then
   Begin
   	Ia:=X+NWd-WINX2;
      NWd:=NWd-Ia;
   End;
	Asm
      push DS
      mov DS,tDS
      mov ES,tES
      mov SI,tSI
      mov DI,tDI
   	mov AX,NY
      mov BX,AX
      shl AX,8
      shl BX,6
      add AX,BX
      add AX,NX
      add DI,AX
      mov AX,320
      sub AX,NWd
      mov I,AX
      mov DX,NHg
     @DT1:
     	mov CX,NWd
      add SI,Ib
	  @DT2:
	  	lodsb
		test AL,0FFh
		jnz @DT3
      inc DI
      loop @DT2
      jmp @DT4
	  @DT3:
	  	stosb
		loop @DT2
     @DT4:
      add SI,Ia
      add DI,I
      dec DX
      jnz @DT1
      pop DS
   End;
End;

Procedure P_SavePRI(FName:String;Buf:Pointer);
Var
	F:File;
   Wd,Hg:Integer;
   SSg,SOf:Word;
Begin
   {$I-}
   Assign(F,FName+'.PRI');
   Rewrite(F,1);
   If IOResult>0 Then
   	Exit;
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   Asm
      push DS
   	mov AX,SSg
      mov DS,AX
      mov SI,SOf
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      pop DS
   End;
   BlockWrite(F,Buf^,Wd*Hg+4);
   Close(F);
   If IOResult>0 Then
   	Exit;
   {$I+}
End;

Procedure P_LoadPRI(FName:String;Buf:Pointer);
Var
	F:File;
   Wd,Hg:Integer;
Begin
   {$I-}
   Assign(F,FName+'.PRI');
   Reset(F,1);
   If IOResult>0 Then
   	Exit;
   BlockRead(F,Wd,2);
   BlockRead(F,Hg,2);
   Seek(F,0);
   BlockRead(F,Buf^,Wd*Hg+4);
   Close(F);
   If IOResult>0 Then
   	Exit;
   {$I+}
End;

Procedure P_SavePRIFile(Var F:File;Buf:Pointer);
Var
   Wd,Hg:Integer;
   SSg,SOf:Word;
Begin
   {$I-}
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   Asm
      push DS
   	mov AX,SSg
      mov DS,AX
      mov SI,SOf
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      pop DS
   End;
   BlockWrite(F,Buf^,Wd*Hg+4);
   If IOResult>0 Then
   	Exit;
   {$I+}
End;

Procedure P_LoadPRIFile(Var F:File;Buf:Pointer);
Var
   Wd,Hg:Integer;
Begin
   {$I-}
   BlockRead(F,Wd,2);
   BlockRead(F,Hg,2);
   Seek(F,FilePos(F)-4);
   BlockRead(F,Buf^,Wd*Hg+4);
   If IOResult>0 Then
   	Exit;
   {$I+}
End;

Function P_LoadPRIalloc(FName:String;Var Buf:Pointer):Boolean;
Var
	F:File;
   Wd,Hg:Integer;
Begin
   {$I-}
   Assign(F,FName+'.PRI');
   Reset(F,1);
   If IOResult>0 Then
   	Exit;
   BlockRead(F,Wd,2);
   BlockRead(F,Hg,2);
   If Wd*Hg+4>MaxAvail Then
   Begin
   	Close(F);
      P_LoadPRIalloc:=False;
      Exit;
   End;
   P_LoadPRIalloc:=True;
   GetMem(Buf,Wd*Hg+4);
   Seek(F,0);
   BlockRead(F,Buf^,Wd*Hg+4);
   Close(F);
   If IOResult>0 Then
   	Exit;
   {$I+}
End;

Procedure P_ShowPRI(FName:String;X,Y:Integer);
Var
	P:Pointer;
Begin
   P:=Nil;
	P_LoadPRIAlloc(FName,P);
   If P=Nil Then
   	Exit;
   P_PutImage(X,Y,P);
   P_DeAlloc(P);
End;

Function P_BufSize(Buf:Pointer):Word;
Var
	SSg,SOf:Word;
   Wd,Hg:Integer;
Begin
   SSg:=Seg(Buf^);
   SOf:=Ofs(Buf^);
   Asm
      push DS
   	mov AX,SSg
      mov DS,AX
      mov SI,SOf
      lodsw
      mov Wd,AX
      lodsw
      mov Hg,AX
      pop DS
   End;
   P_BufSize:=Wd*Hg+4;
End;

Function P_PRISize(FName:String):Word;
Var
	F:File;
   Wd,Hg:Integer;
Begin
   {$I-}
   Assign(F,FName+'.PRI');
   Reset(F,1);
   If IOResult>0 Then
   Begin
      P_PRISize:=65535;
   	Exit;
   End;
   BlockRead(F,Wd,2);
   BlockRead(F,Hg,2);
   Close(F);
   If IOResult>0 Then
   Begin
      P_PRISize:=65535;
   	Exit;
   End;
   {$I+}
   P_PRISize:=Wd*Hg+4;

End;

Procedure P_DeAlloc(Var Buf:Pointer);
Begin
	FreeMem(Buf,P_BufSize(Buf));
End;

Constructor P_Sprite.Init;
Var
	C:Integer;
Begin
	CurSet:=1;
   For C:=1 To 20 Do
   Begin
   	NbFrm[C]:=0;
      CurFrm[C]:=1;
   End;
End;

Procedure P_Sprite.AddFrame(NSet:Byte;NImg:Pointer);
Begin
	Inc(NbFrm[NSet]);
   Img[NSet,NbFrm[NSet]]:=NImg;
End;

Procedure P_Sprite.NewSet(NSet:Byte);
Begin
	CurSet:=NSet;
End;

Procedure P_Sprite.Draw;
Begin
	P_PutImage(X,Y,Img[CurSet,CurFrm[CurSet]]);
End;

Procedure P_Sprite.DrawTrans;
Begin
	P_PutImageTrans(X,Y,Img[CurSet,CurFrm[CurSet]]);
End;

Procedure P_Sprite.DrawClip;
Begin
	P_PutImageClip(X,Y,Img[CurSet,CurFrm[CurSet]]);
End;

Procedure P_Sprite.DrawTransClip;
Begin
	P_PutImageTransClip(X,Y,Img[CurSet,CurFrm[CurSet]]);
End;

Function P_Sprite.Step:Boolean;
Begin
   Step:=False;
	Inc(CurFrm[CurSet]);
   If CurFrm[CurSet]>NbFrm[CurSet] Then
   Begin
   	CurFrm[CurSet]:=1;
      Step:=True;
   End;
End;

Destructor P_Sprite.Done;
Begin
End;


Begin
	P_SetClipRegion(0,0,319,199);
End.