Unit PixText;

Interface

Type
	P_Font=Record
		Fnt:Array[1..127,1..8,1..8] Of Byte;
      Sx,Sy:Byte;
      Ix,Iy:Array[1..127] Of Byte;
      MonoFont:Boolean;
   End;

Procedure P_LoadFont(FName:String);
Procedure P_SaveFont(FName:String);
Procedure P_LoadROMFont;
Procedure P_Write(X,Y:Integer;Col:Byte;St:String);
Procedure P_WriteCenter(Y:Integer;Col:Byte;St:String);
Procedure P_WriteS(X,Y:Integer;Col,SCol:Byte;St:String);
Procedure P_WriteCenterS(Y:Integer;Col,SCol:Byte;St:String);
Function P_Length(St:String):Word;

Var
	Font:P_Font;

Implementation

Uses
	Pix322,PIxSprit;

Procedure PutIt(X,Y:Integer;Col:Byte;Car:Byte);
Var
	P:Array[0..67] of Byte;
   C,Xe:Integer;
   Cx:Integer;
Begin
	P[0]:=Font.Ix[Car];
   P[1]:=0;
   P[2]:=Font.Iy[Car];
   P[3]:=0;
   Cx:=4;
   For C:=1 To Font.Iy[Car] Do
   Begin
		If Font.MonoFont Then
      Begin
      	For Xe:=1 To Font.Ix[Car] Do
      		If Font.Fnt[Car,C,Xe]<>0 Then
         		P[Cx+Xe-1]:=Col
            Else
            	P[Cx+Xe-1]:=0;
      End
      Else
			Move(Font.Fnt[Car,C,1],P[Cx],Font.Ix[Car]);
      Inc(Cx,Font.Ix[Car]);
   End;
   P_PutImageTransClip(X,Y,@P);
End;

Procedure P_LoadFont(FName:String);
Var
	F:File;
Begin
	{$I-}
   Assign(F,FName);
   Reset(F,1);
   BlockRead(F,Font,SizeOf(Font));
   Close(F);
   If IOResult>0 Then
		P_LoadRomFont;
   {$I+}
End;

Procedure P_SaveFont(FName:String);
Var
	F:File;
Begin
	{$I-}
   Assign(F,FName);
   Rewrite(F,1);
   BlockWrite(F,Font,SizeOf(Font));
   Close(F);
   If IOResult>0 Then
		;
   {$I+}
End;

Procedure P_Write(X,Y:Integer;Col:Byte;St:String);
Var
	C:Integer;
Begin
	For C:=1 To Length(St) Do
   Begin
   	PutIt(X,Y,Col,Ord(St[C]));
      Inc(X,Font.Ix[Ord(St[C])]+1);
   End;
End;

Procedure P_WriteCenter(Y:Integer;Col:Byte;St:String);
Var
	X,C:Integer;
Begin
   X:=160-(P_Length(St) div 2);
	For C:=1 To Length(St) Do
   Begin
   	PutIt(X,Y,Col,Ord(St[C]));
      Inc(X,Font.Ix[Ord(St[C])]+1);
   End;
End;

Procedure P_WriteS(X,Y:Integer;Col,SCol:Byte;St:String);
Begin
	P_Write(X+1,Y+1,SCol,St);
	P_Write(X,Y,Col,St);
End;

Procedure P_WriteCenterS(Y:Integer;Col,SCol:Byte;St:String);
Var
	X,C:Integer;
Begin
   X:=160-(P_Length(St) div 2)+1;
	For C:=1 To Length(St) Do
   Begin
   	PutIt(X,Y+1,sCol,Ord(St[C]));
      Inc(X,Font.Ix[Ord(St[C])]+1);
   End;
   P_WriteCenter(Y,Col,St);
End;

Function P_Length(St:String):Word;
Var
	C:Byte;
   T:Word;
Begin
	T:=0;
   For C:=1 To Length(St) Do
   	T:=T+Font.Ix[Ord(St[C])]+1;
	P_Length:=T;
End;

Procedure P_LoadROMFont;
Var
	C,D:Byte;
   B:Byte;
Begin
   Font.Sx:=8;
   Font.Sy:=8;
   Font.MonoFont:=True;
   For C:=1 To 127 Do
   Begin
   	Font.Ix[C]:=8;
      Font.Iy[C]:=8;
   End;
	For C:=1 To 127 Do
   Begin
      For D:=1 To 8 Do
      Begin
			B:=Byte(Ptr($F000,$FA6E+(C*8)+D-1)^);
   		Font.Fnt[C,D,1]:=Ord((B And $80)>0);
   		Font.Fnt[C,D,2]:=Ord((B And $40)>0);
   		Font.Fnt[C,D,3]:=Ord((B And $20)>0);
   		Font.Fnt[C,D,4]:=Ord((B And $10)>0);
   		Font.Fnt[C,D,5]:=Ord((B And $08)>0);
   		Font.Fnt[C,D,6]:=Ord((B And $04)>0);
   		Font.Fnt[C,D,7]:=Ord((B And $02)>0);
   		Font.Fnt[C,D,8]:=Ord((B And $01)>0);
      End;
   End;
End;

Begin
	P_LoadROMFont;
End.